package net.sf.seaf.test.internal.unitils;

import java.util.ArrayList;
import java.util.List;

import org.unitils.reflectionassert.ReflectionComparator;
import org.unitils.reflectionassert.ReflectionComparatorFactory;
import org.unitils.reflectionassert.comparator.Comparator;

public class SeafReflectionComparatorFactory extends
		ReflectionComparatorFactory {

	protected static final Comparator TEMPORAL_COMPARATOR = new TemporalComparator();

	public static ReflectionComparator createRefectionComparator() {
		List<Comparator> comparators = getComparatorChain();
		return new ReflectionComparator(comparators);
	}

	protected static List<Comparator> getComparatorChain() {
		List<Comparator> comparatorChain = new ArrayList<Comparator>();
		comparatorChain.add(TEMPORAL_COMPARATOR);
		comparatorChain.add(LENIENT_NUMBER_COMPARATOR);
		comparatorChain.add(SIMPLE_CASES_COMPARATOR);
		comparatorChain.add(COLLECTION_COMPARATOR);
		comparatorChain.add(MAP_COMPARATOR);
		comparatorChain.add(HIBERNATE_PROXY_COMPARATOR);
		comparatorChain.add(OBJECT_COMPARATOR);
		return comparatorChain;
	}

}
