package net.sf.seaf.test.jmock.matchers;

import java.io.Serializable;

import net.sf.seaf.test.unitils.DeepEquals;

import org.hamcrest.BaseMatcher;
import org.hamcrest.Description;

/**
 * Is the value equal to the other object? The equality is assessed by
 * reflection, delving recursively into child beans.
 */
public class JMockDeepEquals<T> extends BaseMatcher<T> implements Serializable {

	private static final long serialVersionUID = 6091161448661578340L;
	private final Object expected;

	public JMockDeepEquals(Object expected) {
		this.expected = expected;
	}

	public boolean matches(Object actual) {
		DeepEquals.matches(expected, actual);
		return true;
	}

	public void describeTo(Description description) {
	}

}
